VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Main 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text2 
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Text            =   "Text2"
      Top             =   1320
      Width           =   615
   End
   Begin VB.TextBox Text1 
      Height          =   360
      Left            =   240
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   720
      Width           =   615
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   120
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuNew 
         Caption         =   "&New"
      End
      Begin VB.Menu mnuOpen 
         Caption         =   "&Open"
      End
      Begin VB.Menu mnu1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSave 
         Caption         =   "&Save"
      End
      Begin VB.Menu mnuSaveAs 
         Caption         =   "Save &As..."
      End
      Begin VB.Menu mnu2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "&Options"
      Begin VB.Menu mnuSound 
         Caption         =   "Sound"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuLines 
         Caption         =   "Lines"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuPlayers 
         Caption         =   "Players"
         Begin VB.Menu mnuNumPlayers 
            Caption         =   "Two"
            Index           =   2
         End
         Begin VB.Menu mnuNumPlayers 
            Caption         =   "Four"
            Index           =   4
         End
         Begin VB.Menu mnuNumPlayers 
            Caption         =   "Six"
            Index           =   6
         End
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuAssistant 
         Caption         =   "&Assistant"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuContents 
         Caption         =   "&Contents"
      End
      Begin VB.Menu mnu3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuAbout 
         Caption         =   "About Chinese Checkers"
      End
   End
   Begin VB.Menu mnuDebug 
      Caption         =   "Debug"
      Begin VB.Menu mnuGrid 
         Caption         =   "Grid"
      End
   End
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Chinese Checkers
' Copyright  2000, Phillip Senn
' Freely Distribute
' This program uses a fast graphics packaged called Fastgraph.
' You can download a free evaluation copy of Fastgraph at: http://www.fastgraph.com
Option Explicit ' All variables must be Dimmed
Option Base 1   ' Arrays begin with element 1, not 0
DefLng A-Z      ' Everything not explicitly defined will default to Long Integer

Dim AppIsActive
Dim AppPath As String
Dim fg_Buffer(2)

Const BoardWidth = 25
Const BoardHeight = 17

Dim B(-1 To 19, -3 To 29) ' This is the GameBoard
Dim Red, Green, Blue
Dim W ' Width of each token
Dim H ' Height of each token
Dim Winner(BoardHeight, BoardWidth)
Dim PLAYER  ' Who's turn is it?
Dim DotSprite() As Integer
Dim Player1Sprite() As Integer
Dim AssistantSprite() As Integer
Dim DotW, DotH, PlayerW, PlayerH, AssistantW, AssistantH
Dim OldRow, OldCol, OrigRow, OrigCol, PriorJumps, LegalMove
Dim OffSetX, OffSetY
Dim WhosPlaying(6)
Dim OldX As Single, OldY As Single

Private Sub Form_Activate()
If AppIsActive = False Then
   AppIsActive = True
   H = Me.ScaleHeight / BoardHeight
   W = Me.ScaleWidth / BoardWidth
   fg_Buffer(2) = fg_vballoc(Me.ScaleWidth, Me.ScaleHeight)
   Call fg_vbopen(fg_Buffer(2))
   LoadSprite AppPath & "Dot.bmp", DotSprite(), DotW, DotH
   LoadSprite AppPath & "Assistant.bmp", AssistantSprite(), AssistantW, AssistantH
   mnuNumPlayers_Click 2
   
   fg_Buffer(1) = fg_vballoc(Me.ScaleWidth, Me.ScaleHeight)
   Call fg_vbopen(fg_Buffer(1))
   Call fg_copypage(fg_Buffer(2), fg_Buffer(1))
End If
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
Unload Me
End
End Sub

Private Sub Form_Load()
If App.Path = "\" Then AppPath = "\" Else AppPath = App.Path & "\"
With Me
   .ScaleMode = vbPixels
   .Caption = "Chinese Checkers"
   .WindowState = vbNormal
   .Top = 600
   .Left = 0
   .Height = Screen.Height - 1000
   .Width = .Height
   .WindowState = vbMaximized
   .FillStyle = vbFSSolid
   .BorderStyle = vbBSNone
   .Icon = LoadPicture(AppPath & "ChineseCheckers.ico")
   .PaletteMode = vbPaletteModeCustom ' FG User's Guide p. 34
   Call fg_setdc(.hDC)
End With
Call fg_vbinit
Call fg_vbdepth(16)
End Sub

Private Function GetRow(Y As Single)
GetRow = Y \ (Me.ScaleHeight / BoardHeight) + 1
End Function

Private Function GetCol(X As Single)
GetCol = X \ (Me.ScaleWidth / BoardWidth) + 1
End Function

Private Sub Form_Paint()
Call fg_vbpaste(0, fg_getmaxx(), 0, fg_getmaxy(), 0, fg_getmaxy() - 1)
DoEvents
End Sub

Private Sub Form_Unload(Cancel As Integer)
Call fg_vbclose
Call fg_vbfree(-1)
Call fg_vbfin
End Sub

Private Sub mnuAssistant_Click()
mnuAssistant.Checked = Not mnuAssistant.Checked
End Sub

Private Sub mnuExit_Click()
Unload Me
End
End Sub

Private Sub DrawBoard()
Dim Row, Col, X, Y

Call SetColor(0, 255, 255)
Call fg_fillpage ' Cls
Call SetColor(0, 0, 0)
For Row = 1 To BoardHeight
   For Col = 1 To BoardWidth
      If B(Row, Col) <> 0 Then ' If there is ANYTHING at this board position
         X = Col * W - W
         Y = Row * H
         Call fg_move(X, Y)
         Call fg_clipdcb(DotSprite(1), DotW, DotH)
         If mnuLines.Checked Then
            X = X + W / 2
            Y = Y - H / 2
            If B(Row - 1, Col - 1) <> 0 Then
               Call fg_move(X, Y)
               Call fg_draw(X - W, Y - H)
            End If
            If B(Row - 1, Col + 1) <> 0 Then
               Call fg_move(X, Y)
               Call fg_draw(X + W, Y - H)
            End If
            If B(Row - 0, Col + 2) <> 0 Then
               Call fg_move(X, Y)
               Call fg_draw(X + 2 * W, Y)
            End If
         End If
      End If
   Next Col
Next Row
For Row = 1 To BoardHeight
   For Col = 1 To BoardWidth
      Select Case B(Row, Col)
      Case PLAYER
         X = Col * W - W
         Y = Row * H
         Call fg_move(X, Y)
         Call fg_clipdcb(Player1Sprite(1), PlayerW, PlayerH)
      Case Is > 0 ' If there is another player at this board position
         X = Col * W - W \ 2
         Y = Row * H - H \ 2
         Red = 0: Green = 255: Blue = 0
         Call SetColor(Red, Green, Blue)
         Call fg_move(X, Y)
         Call fg_circlef(W / 2)
      End Select
   Next Col
Next Row
If mnuGrid.Checked Then
   Call fg_setcolor(0)
   For Row = 1 To BoardHeight - 1
      Call fg_move(0, Row * H)
      Call fg_draw(fg_getmaxx(), Row * H)
   Next Row
   For Col = 1 To BoardWidth - 1
      Call fg_move(Col * W, 0)
      Call fg_draw(Col * W, fg_getmaxy())
   Next Col
End If
Form_Paint
End Sub

Private Sub mnuGrid_Click()
mnuGrid.Checked = Not mnuGrid.Checked
mnuLines.Checked = Not mnuGrid.Checked
DrawBoard
End Sub

Private Sub mnuNumPlayers_Click(Index As Integer)
Dim I
Dim FN As String
If mnuNumPlayers(Index).Checked Then Exit Sub
FN = AppPath & "ChineseCheckers.DOC"
LoadBoard FN
LoadSprite AppPath & "Player4.bmp", Player1Sprite(), PlayerW, PlayerH
If Index > 2 Then
   For I = 9 To 17 Step 2
      B(5, I) = -1
      B(13, I) = -1
   Next I
End If
If Index = 2 Then
   ClearNumber 2
   ClearNumber 3
   ClearNumber 5
   ClearNumber 6
End If
If Index = 4 Then
   ClearNumber 3
   ClearNumber 6
End If
mnuNumPlayers(2).Checked = False
mnuNumPlayers(4).Checked = False
mnuNumPlayers(6).Checked = False
mnuNumPlayers(Index).Checked = True
DrawBoard
End Sub

Private Sub ClearNumber(Index)
Dim Row, Col
WhosPlaying(Index) = False
For Row = 1 To BoardHeight
   For Col = 1 To BoardWidth
      If B(Row, Col) = Index Then B(Row, Col) = -1
   Next Col
Next Row
End Sub

Private Sub mnuOpen_Click()
Dim FN As String
CommonDialog1.DialogTitle = "Open Game"
CommonDialog1.FileName = "*.DOC"
CommonDialog1.Filter = "*.Doc"
CommonDialog1.InitDir = AppPath
CommonDialog1.ShowOpen
FN = CommonDialog1.FileName
If FN <> "" Then
   LoadBoard FN
   DrawBoard
End If
End Sub

Private Sub mnuLines_Click()
mnuLines.Checked = Not mnuLines.Checked
DrawBoard
End Sub

Private Sub mnuSave_Click()
SaveFile False
End Sub

Private Sub mnuSaveAs_Click()
SaveFile True
End Sub

Private Sub SaveFile(SaveAs)
Static FN As String
Dim Row, Col, F
If SaveAs = True Or FN = "" Then
   CommonDialog1.DialogTitle = "Save Game"
   CommonDialog1.FileName = "*.DOC"
   CommonDialog1.Filter = "*.Doc"
   CommonDialog1.InitDir = AppPath
   CommonDialog1.ShowSave
End If
If InStr(FN, ".") = 0 Then
   FN = FN & ".DOC"
End If
If UCase(Right$(FN, 4)) <> ".DOC" Then
   MsgBox "Must have .txt extension"
Else
   F = FreeFile()
   Open FN For Output As #F
   Print #F, "    1234567890123456789012345" ' Header Record
   For Row = 1 To BoardHeight
      Print #F, Format(Row, "00  ");
      For Col = 1 To BoardWidth
         Select Case B(Row, Col)
            Case -1: Print #F, ".";
            Case 0: Print #F, " ";
            Case Else
               Print #F, Format(B(Row, Col), "#");
         End Select
      Next Col
      Print #F, ""
   Next Row
   Close #F
End If
End Sub

Private Sub PLAY(What As String)
Dim I
If mnuSound.Checked Then
   I = PlaySound(AppPath & What & ".wav", 0, SND_FILENAME Or SND_ASYNC)
End If
End Sub

Private Sub LoadBoard(FN As String)
Dim F, I, Row, Col
Dim A As String

F = FreeFile()
Open FN For Input As #F
Line Input #F, A ' Header Record
For Row = 1 To BoardHeight
   Line Input #F, A
   For Col = 1 To BoardWidth
      Select Case Mid$(A, Col + 4, 1)
      Case "."
         B(Row, Col) = -1
      Case " "
         B(Row, Col) = 0
      Case Else
         I = Val(Mid$(A, Col + 4, 1))
         B(Row, Col) = I
         If I > 0 Then WhosPlaying(I) = True
         If I > 3 Then
            Winner(Row, Col) = I - 3
         Else
            Winner(Row, Col) = I + 3
         End If
      End Select
   Next Col
Next Row
Line Input #F, A
PLAYER = Val(Mid(A, 7, 1))
Close #F
End Sub

Private Sub LoadSprite(SpriteName As String, Sprite() As Integer, SpriteWidth, SpriteHeight)
Dim F
Dim FileHeader(128) As Byte

F = FreeFile()
If fg_bmphead(SpriteName, FileHeader(1)) < 0 Then
   Call MsgBox(SpriteName + vbCr + " is not a BMP file.", vbCritical, "Error")
Else
   Call fg_bmpsize(FileHeader(1), SpriteWidth, SpriteHeight)
   ReDim Sprite(SpriteWidth * SpriteHeight) As Integer
   Call fg_showbmp(SpriteName, 0)
   Call fg_move(0, SpriteHeight - 1)
   Call fg_getdcb(Sprite(1), SpriteWidth, SpriteHeight)
End If
End Sub

Public Function Valid(CurCol, CurRow, Col, Row, Prior)
Dim SgnCol, SgnRow
If B(Row, Col) = -1 Then
   If Prior = 0 Then
      If Abs(Col - CurCol) = 1 And Abs(Row - CurRow) = 1 Then Valid = 1
      If Abs(Col - CurCol) = 2 And Abs(Row - CurRow) = 0 Then Valid = 1
   End If
   If Prior = 0 Or Prior = 2 Then
      SgnCol = Sgn(Col - CurCol)
      SgnRow = Sgn(Row - CurRow)
      If B(CurRow + SgnRow, CurCol + SgnCol) > 0 Then
         If Abs(Col - CurCol) = 2 And Abs(Row - CurRow) = 2 Then
            Valid = 2
         End If
      End If
      If B(CurRow + 2 * SgnRow, CurCol + 2 * SgnCol) > 0 Then
         If Abs(Col - CurCol) = 4 And Abs(Row - CurRow) = 0 Then
            Valid = 2
         End If
      End If
   End If
End If
End Function

Public Sub ShowRecursive(Col, Row)
Dim C, R
For R = Row - 2 To Row + 2
   For C = Col - 4 To Col + 4
      If Valid(Col, Row, C, R, 2) = 2 Then
         Call fg_move(C * W - W, R * H)
         Call fg_clipdcb(AssistantSprite(1), AssistantW, AssistantH)
         B(Row, Col) = 7
         ShowRecursive C, R
         B(Row, Col) = -1
      End If
   Next C
Next R
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim Row, Col, R, C, Mvmnt
If Button = 1 And Shift = 0 Then
   Row = GetRow(Y)
   Col = GetCol(X)
   If B(Row, Col) = PLAYER Then
      If mnuAssistant.Checked Then
         For R = Row = 2 To Row + 2
            For C = Col - 4 To Col + 4
               Mvmnt = Valid(Col, Row, C, R, 0)
               If Mvmnt > 0 Then
                  Call fg_move(C * W - W, R * H)
                  Call fg_clipdcb(AssistantSprite(1), AssistantW, AssistantH)
                  If Mvmnt = 2 Then ShowRecursive C, R
               End If
            Next C
         Next R
         Call fg_copypage(fg_Buffer(1), fg_Buffer(2))
         Form_Paint
      End If
      OrigCol = Col: OldCol = Col: OldX = X
      OrigRow = Row: OldRow = Row: OldY = Y
      OffSetX = X - (Col * W - W)
      OffSetY = (Row * H) - Y
      PriorJumps = 0
   End If
End If
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Not LegalMove Then
   B(OldRow, OldCol) = -1
   B(OrigRow, OrigCol) = PLAYER
End If
OldCol = 0
PriorJumps = 0
DrawBoard
If LegalMove Then GetNextPlayer
End Sub

Private Sub GetNextPlayer()
'Do
'   PLAYER = PLAYER Mod 6 + 1
'Loop Until WhosPlaying(PLAYER)
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim Row, Col, I
If Button = 1 And OldCol > 0 Then
   DrawPlayer OldX, OldY, X, Y
   OldX = X
   OldY = Y
   Row = GetRow(Y)
   Col = GetCol(X)
   If Row <> OldRow Or Col <> OldCol Then
      LegalMove = False
      I = Valid(OrigCol, OrigRow, Col, Row, 0)
      If I = 1 And (OldRow <> Row Or OldCol <> Col) Then
         PLAY "ChineseCheckersMove1"
         B(OldRow, OldCol) = -1
         B(Row, Col) = PLAYER
         OldRow = Row
         OldCol = Col
         PriorJumps = 1
         LegalMove = True
      End If
      If PriorJumps > 0 And Row = OrigRow And Col = OrigCol Then
         PLAY "ChineseCheckersMove1"
         B(OldRow, OldCol) = -1
         B(Row, Col) = PLAYER
         OldRow = Row
         OldCol = Col
         PriorJumps = 0
      End If
      I = Valid(OldCol, OldRow, Col, Row, PriorJumps)
      If I = 2 Then
         PLAY "ChineseCheckersMove" & I
         B(OldRow, OldCol) = -1
         B(Row, Col) = PLAYER
         OldRow = Row
         OldCol = Col
         PriorJumps = 2
         LegalMove = True
      End If
   End If
End If
End Sub

Private Sub DrawPlayer(OldX As Single, OldY As Single, X As Single, Y As Single)
Dim PaneTop, PaneBottom, PaneLeft, PaneRight

PaneLeft = OldX - OffSetX
PaneBottom = OldY + OffSetY
PaneTop = PaneBottom - PlayerH
PaneRight = PaneLeft + PlayerW
Call fg_vbcopy(PaneLeft, PaneRight, PaneTop, PaneBottom, PaneLeft, PaneBottom, fg_Buffer(2), fg_Buffer(1))
Call fg_vbpaste(PaneLeft, PaneRight, PaneTop, PaneBottom, PaneLeft, PaneBottom - 1)
PaneLeft = X - OffSetX
PaneBottom = Y + OffSetY
PaneTop = PaneBottom - PlayerH
PaneRight = PaneLeft + PlayerW
Call fg_move(PaneLeft, PaneBottom)
Call fg_clipdcb(Player1Sprite(1), PlayerW, PlayerH)
If PaneLeft < 0 Or PaneTop < 0 Or PaneRight > Me.ScaleWidth Or PaneBottom > Me.ScaleHeight Then
   Form_MouseUp 1, 0, OldX, OldY
Else
   Call fg_vbpaste(PaneLeft, PaneRight, PaneTop, PaneBottom, PaneLeft, PaneBottom - 1)
   Form_Paint
End If
End Sub

